// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "SAnalyzer.h"

#include "LeftView.h"
#include "RightView.h"
#include "CanDoc.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CQueue

CQueue::CQueue()
{
	Clear();
}

CQueue::~CQueue()
{

}

void CQueue::Clear()
{
	m_nHead = m_nTail = 0;
	::ZeroMemory(RX_BUF, BUFF_SIZE);
}

int CQueue::GetSize()
{
	return (m_nHead - m_nTail + BUFF_SIZE) % BUFF_SIZE;
}

BOOL CQueue::GetData(char* pcData)
{
	if(GetSize() == 0)
		return FALSE;

	*pcData = RX_BUF[m_nTail++];
	m_nTail %= BUFF_SIZE;
	return TRUE;
}

BOOL CQueue::PutData(char cData)
{
	if(GetSize() == (BUFF_SIZE-1))
		return FALSE;

	RX_BUF[m_nHead++] = cData;
	m_nHead %= BUFF_SIZE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_COMMAND(ID_RECEIVE_START, OnReceiveStart)
	ON_COMMAND(ID_RECEIVE_STOP, OnReceiveStop)
	ON_COMMAND(ID_RESET, OnReset)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_COMM_READ, OnReadRxData)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_TRANSMODE,
	ID_INDICATOR_PROTOCOL,
	ID_INDICATOR_BPS,
	ID_INDICATOR_MASK,
	ID_INDICATOR_ARBITOR,
	ID_INDICATOR_RECEIVE,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	// Main Frame ġ  ʱȭ
	CString strSection = _T("Main Configuration");
	CCanApp* pApp = (CCanApp*)AfxGetApp();

	// COM Port 
	m_bPortOpened = FALSE;
	m_hComID = NULL;
	::ZeroMemory(&m_osRead, sizeof(OVERLAPPED));
	::ZeroMemory(&m_osWrite, sizeof(OVERLAPPED));

	// Thread 
	m_hComThread = NULL;
	m_bExitThread = FALSE;

	////////////////////////////////
	// Basic  
	m_bReceiveON = FALSE;
	m_bCommSetON = FALSE;

	// ModBus 
	m_bAsEnd = FALSE;
	m_bAsRON = FALSE;
	m_nAsRCnt = 0;
	::ZeroMemory(Receive_Buff, sizeof(Receive_Buff));
	::ZeroMemory(Receive_Data, sizeof(Receive_Data));

}

CMainFrame::~CMainFrame()
{

}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	m_Queue.Clear();

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnDestroy()
{
	//  Ʈ ݱ
	CloseComPort();

	CFrameWnd::OnDestroy();
}

void CMainFrame::OnTimer(UINT nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	if(nIDEvent == 2002)
	{
		if(m_bCommSetON == TRUE)
		{
			if(m_hComThread != NULL)
				SuspendThread(m_hComThread);

			// CAN Analyzerκ  
			PurgeComm(m_hComID, PURGE_RXABORT | PURGE_RXCLEAR | PURGE_TXABORT | PURGE_TXCLEAR);
			m_Queue.Clear();
			m_bCommSetON = FALSE;

			if(m_hComThread != NULL)
				ResumeThread(m_hComThread);
		}

		KillTimer(nIDEvent);
	}

	CFrameWnd::OnTimer(nIDEvent);
}

bool CMainFrame::OpenComPort()
{
	if(!m_bDeviceExist)
		return FALSE;

	if(m_hComID != NULL)
		return TRUE;

	CString szPortName;
	HANDLE  hPortID;
	BOOL    bRet;

	// Overlapped Structure  ʱȭ
	m_osRead.Offset = 0;
	m_osRead.OffsetHigh = 0;
	m_osWrite.Offset = 0;
	m_osWrite.OffsetHigh = 0;
	if(!(m_osRead.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL)))
		return FALSE;

	if(!(m_osWrite.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL)))
	{
		CloseHandle(m_osRead.hEvent);
		::ZeroMemory(&m_osRead, sizeof(OVERLAPPED));
		return FALSE;
	}

	// Port Handle ´.
	// szPortName : "COM1"  USB  Serial Port Name μ
	// ǿ CAN Analyzer   Serial Port Name ȮϽʽÿ.
	szPortName = GetPortName();
	if(szPortName.IsEmpty())
	{
		CloseHandle(m_osRead.hEvent);
		::ZeroMemory(&m_osRead, sizeof(OVERLAPPED));
		CloseHandle(m_osWrite.hEvent);
		::ZeroMemory(&m_osWrite, sizeof(OVERLAPPED));
		return FALSE;
	}

	hPortID = CreateFile(szPortName, GENERIC_READ | GENERIC_WRITE, 0, NULL,	OPEN_EXISTING,
						 FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED, NULL);
	if(hPortID == INVALID_HANDLE_VALUE)
	{
		CloseHandle(m_osRead.hEvent);
		::ZeroMemory(&m_osRead, sizeof(OVERLAPPED));
		CloseHandle(m_osWrite.hEvent);
		::ZeroMemory(&m_osWrite, sizeof(OVERLAPPED));
		return FALSE;
	}

	// EV_RXCHAR Event 
	bRet = SetCommMask(hPortID, EV_RXCHAR);
	if(!bRet)
	{
		CloseHandle(m_osRead.hEvent);
		::ZeroMemory(&m_osRead, sizeof(OVERLAPPED));
		CloseHandle(m_osWrite.hEvent);
		::ZeroMemory(&m_osWrite, sizeof(OVERLAPPED));

		CloseHandle(hPortID);
		return FALSE;
	}

	//  ũ⸦ Ѵ.
	bRet = SetupComm(hPortID, 4096, 4096);
	if(!bRet)
	{
		CloseHandle(m_osRead.hEvent);
		::ZeroMemory(&m_osRead, sizeof(OVERLAPPED));
		CloseHandle(m_osWrite.hEvent);
		::ZeroMemory(&m_osWrite, sizeof(OVERLAPPED));

		CloseHandle(hPortID);
		return FALSE;
	}

	// COM Device ClearѴ.
	bRet = PurgeComm(hPortID, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
	if(!bRet)
	{
		CloseHandle(m_osRead.hEvent);
		::ZeroMemory(&m_osRead, sizeof(OVERLAPPED));
		CloseHandle(m_osWrite.hEvent);
		::ZeroMemory(&m_osWrite, sizeof(OVERLAPPED));

		CloseHandle(hPortID);
		return FALSE;
	}

    //  Timeout Ѵ.
	COMMTIMEOUTS CommTimeOuts;
	CommTimeOuts.ReadIntervalTimeout = 0xffffffff;
	CommTimeOuts.ReadTotalTimeoutMultiplier = 0;
	CommTimeOuts.ReadTotalTimeoutConstant = 0;
	CommTimeOuts.WriteTotalTimeoutMultiplier = (2*CBR_9600)/CBR_115200;
	CommTimeOuts.WriteTotalTimeoutConstant = 0;
	bRet = SetCommTimeouts(hPortID, &CommTimeOuts);
	if(!bRet)
	{
		CloseHandle(m_osRead.hEvent);
		::ZeroMemory(&m_osRead, sizeof(OVERLAPPED));
		CloseHandle(m_osWrite.hEvent);
		::ZeroMemory(&m_osWrite, sizeof(OVERLAPPED));

		CloseHandle(hPortID);
		return FALSE;
	}

	// DCB Block 
	DCB CommDCB;
	CommDCB.DCBlength = sizeof(DCB);
	bRet = GetCommState(hPortID, &CommDCB);
	if(!bRet)
	{
		CloseHandle(m_osRead.hEvent);
		::ZeroMemory(&m_osRead, sizeof(OVERLAPPED));
		CloseHandle(m_osWrite.hEvent);
		::ZeroMemory(&m_osWrite, sizeof(OVERLAPPED));

		CloseHandle(hPortID);
		return FALSE;
	}

	CommDCB.BaudRate = 460800;
	CommDCB.Parity = NOPARITY;
	CommDCB.ByteSize = 8;
	CommDCB.StopBits = ONESTOPBIT;
    bRet = SetCommState(hPortID, &CommDCB);
	if(!bRet)
	{
		CloseHandle(m_osRead.hEvent);
		::ZeroMemory(&m_osRead, sizeof(OVERLAPPED));
		CloseHandle(m_osWrite.hEvent);
		::ZeroMemory(&m_osWrite, sizeof(OVERLAPPED));

		CloseHandle(hPortID);
		return FALSE;
	}

	m_hComID = hPortID;

	if(!MakeComThread())
		CloseComPort();

	if(!SetRcvOFF())
		CloseComPort();

	m_bPortOpened = TRUE;
	return TRUE;
}

void CMainFrame::CloseComPort()
{
	if(m_osRead.hEvent != NULL)
	{
		CloseHandle(m_osRead.hEvent);
		::ZeroMemory(&m_osRead, sizeof(OVERLAPPED));
	}

	if(m_osWrite.hEvent != NULL)
	{
		CloseHandle(m_osRead.hEvent);
		::ZeroMemory(&m_osWrite, sizeof(OVERLAPPED));
	}

	if(m_hComID != NULL)
	{
		DestroyComThread();
		CloseHandle(m_hComID);
		m_hComID = NULL;
	}

	m_bPortOpened = FALSE;
}

DWORD CMainFrame::WriteComm(char* pBuff, DWORD nToWrite)
{
	DWORD dwWritten, dwError, dwErrorFlags;
	COMSTAT comstat;

	if(!WriteFile(m_hComID, pBuff, nToWrite, &dwWritten, &m_osWrite))
	{
		if(GetLastError() == ERROR_IO_PENDING)
		{
			while(!GetOverlappedResult(m_hComID, &m_osWrite, &dwWritten, TRUE))
			{
				dwError = GetLastError();
				if(dwError != ERROR_IO_INCOMPLETE)
				{
					ClearCommError(m_hComID, &dwErrorFlags, &comstat);
					break;
				}
			}
		}
		else
		{
			dwWritten = 0;
			ClearCommError(m_hComID, &dwErrorFlags, &comstat);
		}
	}

	return dwWritten;
}

DWORD CMainFrame::ReadComm(char* pBuff, DWORD nToRead)
{
	DWORD dwRead, dwError, dwErrorFlags;
	COMSTAT comstat;

	ClearCommError(m_hComID, &dwErrorFlags, &comstat);
	dwRead = comstat.cbInQue;

	if(dwRead > 0)
	{
		if(!ReadFile(m_hComID, pBuff, nToRead, &dwRead, &m_osRead))
		{
			if(GetLastError() == ERROR_IO_PENDING)
			{
				while(!GetOverlappedResult(m_hComID, &m_osRead, &dwRead, TRUE))
				{
					dwError = GetLastError();
					if(dwError != ERROR_IO_INCOMPLETE)
					{
						ClearCommError(m_hComID, &dwErrorFlags, &comstat);
						break;
					}
				}
			}
			else
			{
				dwRead = 0;
				ClearCommError(m_hComID, &dwErrorFlags, &comstat);
			}
		}
	}

	return dwRead;
}

void CMainFrame::WriteCommError()
{
	if(m_hComThread != NULL)
		SuspendThread(m_hComThread);

	// ø Ʈ ͸ µ 
    PurgeComm(m_hComID, PURGE_RXABORT | PURGE_RXCLEAR | PURGE_TXABORT | PURGE_TXCLEAR);
	m_Queue.Clear();

	if(m_hComThread != NULL)
		ResumeThread(m_hComThread);
}

BOOL CMainFrame::MakeComThread()
{
	if(m_hComThread != NULL)
		return TRUE;

	// COM Port Thread 
	DWORD dwThreadID;
	if(m_hComThread == NULL)
	{
		m_hComThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ComThreadProc,
									this, 0, &dwThreadID);
		if(!m_hComThread)
			return FALSE;

		m_bExitThread = FALSE;
	}

	return TRUE;
}

BOOL CMainFrame::DestroyComThread()
{
	if(m_hComThread != NULL)
	{
		DWORD dwExitCode;
		m_bExitThread = TRUE;

		GetExitCodeThread(m_hComThread, &dwExitCode);
		TerminateThread(m_hComThread, dwExitCode);
		m_hComThread = NULL;
	}

	return TRUE;
}

UINT CMainFrame::ComThreadProc(LPVOID lParam)
{
	CMainFrame* pFrame = (CMainFrame*)lParam;
	DWORD		dwEvent=0, dwRead;
	OVERLAPPED	osEvent;
	char		buff[BUFF_SIZE];
	BOOL		bRet = TRUE;

	::ZeroMemory(&osEvent, sizeof(OVERLAPPED));
	if(!(osEvent.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL)))
		bRet = FALSE;
	if(!SetCommMask(pFrame->m_hComID, EV_RXCHAR))
		bRet = FALSE;

	if(!bRet)
	{
		CloseHandle(osEvent.hEvent);
		return bRet;
	}

	while(!pFrame->m_bExitThread)
	{
		dwEvent = 0;
		WaitCommEvent(pFrame->m_hComID, &dwEvent, NULL);

		if((dwEvent & EV_RXCHAR) == EV_RXCHAR)
		{
			do
			{
				dwRead = pFrame->ReadComm(buff, BUFF_SIZE);
				if(BUFF_SIZE - pFrame->m_Queue.GetSize() > (int)dwRead)
				{
					for(WORD i=0; i<dwRead; i++)
						pFrame->m_Queue.PutData(buff[i]);
				}
			} while(dwRead);

			::PostMessage(pFrame->m_hWnd, WM_COMM_READ, 0, 0);
		}
	}

	CloseHandle(osEvent.hEvent);
	pFrame->m_hComThread = NULL;
	return TRUE;
}

LONG CMainFrame::OnReadRxData(WPARAM wParam, LPARAM lParam)
{
	char buff[BUFF_SIZE+1];
	int nLength = m_Queue.GetSize();
	CString szDumy;

	if(nLength > 0)
	{
		for(int i=0; i<nLength; i++)
			m_Queue.GetData(buff+i);

		buff[nLength] = 0;
		szDumy = CString(buff);
		ModBusReceive(szDumy, nLength);
	}

	return 0;
}

BOOL CMainFrame::ModBusReceive(LPCTSTR szData, int nLength)
{
	BYTE	byTemp;
	int i, j, iTemp;
	char    cTemp[BUFF_SIZE+1];
	strcpy(cTemp, szData);

	for(j=0; j<nLength; j++)
	{
		byTemp = (BYTE)cTemp[j];

		if(byTemp == 58)
		{
			m_bAsRON = TRUE;
			m_nAsRCnt = 0;
		}
		else if((byTemp == 13) && (m_bAsRON == TRUE))
			m_bAsEnd = TRUE;
		else if((byTemp == 10) && (m_bAsEnd == TRUE) && (m_nAsRCnt > 5))
		{
			m_bAsEnd = FALSE;
			m_bAsRON = FALSE;

			m_nAsRCnt = (m_nAsRCnt/2) - 1;

			for(i=0; i<=m_nAsRCnt; i++)
				Receive_Data[i] = (Receive_Buff[2*i]*16) + (Receive_Buff[(2*i)+1]);

			iTemp = 0;
			for(i=0; i<=(m_nAsRCnt-1); i++)
				iTemp = iTemp + Receive_Data[i];

			iTemp = iTemp % 256;
			byTemp = (BYTE)iTemp;
			if(byTemp > 0)
				byTemp = 256 - byTemp;

			if(byTemp == Receive_Data[m_nAsRCnt])	//  
			{
				if(Receive_Data[0] == 129)			//  б 
				{
					SetReadAns(FALSE);
					m_bCommSetON = FALSE;
				}
				else if(Receive_Data[0] == 130)		// Ÿ б 
				{
					if(m_bReceiveON == TRUE)
						DataReadAns();
				}
				else if(Receive_Data[0] == 131)		//   
				{
					SetReadAns(TRUE);
					m_bCommSetON = FALSE;
				}
				else if(Receive_Data[0] == 132)		// Ÿ  
				{
					DataWriteAns();
					m_bCommSetON = FALSE;
				}
				else if(Receive_Data[0] == 133)		//  ON/OFF 
				{
					if(Receive_Data[1] == 1)		//  ON
						m_bReceiveON = TRUE;
					else							//  OFF
						m_bReceiveON = FALSE;

					m_bCommSetON = FALSE;
				}
				else if(Receive_Data[0] == 134)
				{
					DevResetAns();
					m_bCommSetON = FALSE;
				}
			}

			m_nAsRCnt = 0;
		}
		else if((m_bAsRON == TRUE) && (m_bAsEnd == TRUE))
			m_bAsRON = FALSE;
		else if(m_bAsRON == TRUE)
		{
			if((byTemp >= 65) && (byTemp <= 70))
				Receive_Buff[m_nAsRCnt] = byTemp - 55;
			else if((byTemp >= 48) && (byTemp <= 57))
				Receive_Buff[m_nAsRCnt] = byTemp - 48;
			else if((byTemp >= 97) && (byTemp <= 102))
				Receive_Buff[m_nAsRCnt] = byTemp - 87;
			else
				Receive_Buff[m_nAsRCnt] = 0;

			m_nAsRCnt++;
			if(m_nAsRCnt >= 40)
			{
				m_bAsRON = FALSE;
				m_nAsRCnt = 0;
			}
		}
	}

	return TRUE;
}

BOOL CMainFrame::SetRcvON()
{
	CString szCommand = CString(_T(":0501FA\r\n"));
	char WData[20];
	DWORD dwWriteSize=0, dwWrittenSize=0;

	if(m_bReceiveON == TRUE)
		return TRUE;

	//  
	dwWriteSize = szCommand.GetLength();
	strcpy(WData, (LPCTSTR)szCommand);
	dwWrittenSize = WriteComm(WData, dwWriteSize);
	if(dwWriteSize != dwWrittenSize)
		return FALSE;

	AddNewMsg(_T("  ͸ մϴ."));
	SetReceiveStatus(ID_INDICATOR_RECEIVE, _T(""), TRUE);
	return TRUE;
}

BOOL CMainFrame::SetRcvOFF()
{
	CString szCommand = CString(_T(":0500FB\r\n"));
	char WData[20];
	DWORD dwWriteSize=0, dwWrittenSize=0;

	if(m_bReceiveON == FALSE)
		return TRUE;

	//  
	dwWriteSize = szCommand.GetLength();
	strcpy(WData, (LPCTSTR)szCommand);
	dwWrittenSize = WriteComm(WData, dwWriteSize);
	if(dwWriteSize != dwWrittenSize)
		return FALSE;

	AddNewMsg(_T("  ͸ մϴ."));
	SetReceiveStatus(ID_INDICATOR_RECEIVE, _T(""), FALSE);
	return TRUE;
}

BOOL CMainFrame::ReadCanEnv()
{
	CString szCommand = CString(_T(":01FF\r\n"));
	char WData[20];
	DWORD dwWriteSize=0, dwWrittenSize=0;

	//  
	dwWriteSize = szCommand.GetLength();
	strcpy(WData, (LPCTSTR)szCommand);
	dwWrittenSize = WriteComm(WData, dwWriteSize);
	if(dwWriteSize != dwWrittenSize)
		return FALSE;

	return TRUE;
}

BOOL CMainFrame::SetDevReset()
{
	CString szCommand = CString(_T(":0600FA\r\n"));
	char WData[20];
	DWORD dwWriteSize=0, dwWrittenSize=0;

	//  
	dwWriteSize = szCommand.GetLength();
	strcpy(WData, (LPCTSTR)szCommand);
	dwWrittenSize = WriteComm(WData, dwWriteSize);
	if(dwWriteSize != dwWrittenSize)
		return FALSE;

	return TRUE;
}

void CMainFrame::DevResetAns()
{
	AddNewMsg(_T("CAN Analyzer ʱȭǾ,  Ÿ ͸  Դϴ."), CLR_BLUE);
	m_bReceiveON = FALSE;
}

void CMainFrame::SetReadAns(BOOL bWrite)
{
	CString szMsg, szDumy;

	if(bWrite)
		szMsg = _T("[CAN Analyzer   ] - ");
	else
		szMsg = _T("[CAN Analyzer   б] - ");

	// CAN Protocol
	if(Receive_Data[3] & 128)
	{
		m_nProtocol = CAN_EXT;
		szDumy = _T(" : Ext(2.0B)");
		szMsg += szDumy;
		SetReceiveStatus(ID_INDICATOR_PROTOCOL, szDumy);
	}
	else
	{
		m_nProtocol = CAN_STD;
		szDumy = _T(" : Std(2.0A)");
		szMsg += szDumy;
		SetReceiveStatus(ID_INDICATOR_PROTOCOL, szDumy);
	}
	szMsg += _T(", ");

	// CAN BPS
	switch(Receive_Data[1])
	{
	case 0:
		m_nBps = BPS_1M;
		szDumy = _T("BPS : 1M");
		szMsg += szDumy;
		SetReceiveStatus(ID_INDICATOR_BPS, szDumy);
		break;
	case 1:
		m_nBps = BPS_500K;
		szDumy = _T("BPS : 500K");
		szMsg += szDumy;
		SetReceiveStatus(ID_INDICATOR_BPS, szDumy);
		break;
	case 3:
		m_nBps = BPS_250K;
		szDumy = _T("BPS : 250K");
		szMsg += szDumy;
		SetReceiveStatus(ID_INDICATOR_BPS, szDumy);
		break;
	case 4:
		m_nBps = BPS_200K;
		szDumy = _T("BPS : 200K");
		szMsg += szDumy;
		SetReceiveStatus(ID_INDICATOR_BPS, szDumy);
		break;
	case 7:
		m_nBps = BPS_125K;
		szDumy = _T("BPS : 125K");
		szMsg += szDumy;
		SetReceiveStatus(ID_INDICATOR_BPS, szDumy);
		break;
	case 9:
		m_nBps = BPS_100K;
		szDumy = _T("BPS : 100K");
		szMsg += szDumy;
		SetReceiveStatus(ID_INDICATOR_BPS, szDumy);
		break;
	case 19:
		m_nBps = BPS_50K;
		szDumy = _T("BPS : 50K");
		szMsg += szDumy;
		SetReceiveStatus(ID_INDICATOR_BPS, szDumy);
		break;
	case 24:
		m_nBps = BPS_40K;
		szDumy = _T("BPS : 40K");
		szMsg += szDumy;
		SetReceiveStatus(ID_INDICATOR_BPS, szDumy);
		break;
	case 39:
		m_nBps = BPS_25K;
		szDumy = _T("BPS : 25K");
		szMsg += szDumy;
		SetReceiveStatus(ID_INDICATOR_BPS, szDumy);
		break;
	case 49:
		m_nBps = BPS_20K;
		szDumy = _T("BPS : 20K");
		szMsg += szDumy;
		SetReceiveStatus(ID_INDICATOR_BPS, szDumy);
		break;
	default:
		m_nBps = BPS_250K;
		break;
	}
	szMsg += _T(", ");

	DWORD dwDumy[4];
	// Receive Mask 
	if(m_nProtocol == CAN_EXT)
	{
		szDumy.Format(_T(" Mask : %02X %02X %02X %02X"),
			Receive_Data[4], Receive_Data[5], Receive_Data[6], Receive_Data[7] & 0xf8);

		dwDumy[0] = (DWORD)Receive_Data[4];
		dwDumy[1] = (DWORD)Receive_Data[5];
		dwDumy[2] = (DWORD)Receive_Data[6];
		dwDumy[3] = (DWORD)(Receive_Data[7] & 0xf8);
	}
	else
	{
		szDumy.Format(_T(" Mask : %02X %02X"),
			Receive_Data[4], Receive_Data[5] & 0xe0);

		dwDumy[0] = (DWORD)Receive_Data[4];
		dwDumy[1] = (DWORD)(Receive_Data[5] & 0xe0);
		dwDumy[2] = 0x0;
		dwDumy[3] = 0x0;
	}

	m_nRecMask = (dwDumy[0] << 24) + (dwDumy[1] << 16) + (dwDumy[2] << 8) + dwDumy[3];
	szMsg += szDumy;
	SetReceiveStatus(ID_INDICATOR_MASK, szDumy);
	szMsg += _T(", ");

	// Receive Arbiter 
	if(m_nProtocol == CAN_EXT)
	{
		szDumy.Format(_T(" Arbiter : %02X %02X %02X %02X"),
			Receive_Data[8], Receive_Data[9], Receive_Data[10], Receive_Data[11] & 0xf8);

		dwDumy[0] = (DWORD)Receive_Data[8];
		dwDumy[1] = (DWORD)Receive_Data[9];
		dwDumy[2] = (DWORD)Receive_Data[10];
		dwDumy[3] = (DWORD)(Receive_Data[11] & 0xf8);
	}
	else
	{
		szDumy.Format(_T(" Arbiter : %02X %02X"),
			Receive_Data[8], Receive_Data[9]);

		dwDumy[0] = (DWORD)Receive_Data[8];
		dwDumy[1] = (DWORD)(Receive_Data[9] & 0xe0);
		dwDumy[2] = 0x0;
		dwDumy[3] = 0x0;
	}

	if(!bWrite)
	{
		if(Receive_Data[11] & 0x1)
			SetReceiveStatus(ID_INDICATOR_TRANSMODE, _T("ڵ"), TRUE);
		else
			SetReceiveStatus(ID_INDICATOR_TRANSMODE, _T(""), FALSE);
	}

	m_nRecArbitor = (dwDumy[0] << 24) + (dwDumy[1] << 16) + (dwDumy[2] << 8) + dwDumy[3];
	szMsg += szDumy;
	SetReceiveStatus(ID_INDICATOR_ARBITOR, szDumy);

	AddNewMsg(szMsg);
}

BOOL CMainFrame::WriteCanEnv(CString szCommand)
{
	char WData[35];
	DWORD dwWriteSize=0, dwWrittenSize=0;

	/*   
	   H(:) CMD(03) STATUS(6bytes) MASK(8bytes) ARBIT(8bytes) CRC(2bytes) CR LF
	*/
	if(szCommand.IsEmpty())
		return FALSE;

	//  
	dwWriteSize = szCommand.GetLength();
	strcpy(WData, (LPCTSTR)szCommand);
	dwWrittenSize = WriteComm(WData, dwWriteSize);
	if(dwWriteSize != dwWrittenSize)
		return FALSE;

	return TRUE;
}

BOOL CMainFrame::ModBusDWrite(CString szCommand)
{
	char WData[35];
	DWORD dwWriteSize=0, dwWrittenSize=0;

	/* Data Write Protocol Format
	   H(:) CMD(04) DataLen(2bytes) Arbit(8bytes) Data(0~16bytes) CRC(2bytes) CR LF
	*/
	if(szCommand.IsEmpty())
		return FALSE;

	//  
	dwWriteSize = szCommand.GetLength();
	strcpy(WData, (LPCTSTR)szCommand);
	dwWrittenSize = WriteComm(WData, dwWriteSize);
	if(dwWriteSize != dwWrittenSize)
		return FALSE;

	return TRUE;
}

void CMainFrame::DataWriteAns()
{
	int i;
	CString szDumy, szMsg;
	BYTE byDumy, nLength;

	szMsg = _T("[Ÿ ۽ ] - ");
	// CAN Protocol
	if(Receive_Data[1] >= 128)
	{
		szMsg += _T(" : Ext(2.0B), ");
		nLength = 3;
	}
	else
	{
		szMsg += _T(" : Std(2.0A), ");
		nLength = 1;
	}

	//  
	byDumy = Receive_Data[1] % 128;
	if(byDumy >= 64)
	{
		szMsg += _T(", ");
		SetReceiveStatus(ID_INDICATOR_TRANSMODE, _T(""), FALSE);
		byDumy = byDumy % 64;
	}
	else
	{
		szMsg += _T("ڵ, ");
		SetReceiveStatus(ID_INDICATOR_TRANSMODE, _T("ڵ"), TRUE);
	}

	// Trans Arbiter

	szMsg += _T("۽ Arbiter : ");
	for(i=0; i<=(int)nLength; i++)
	{
		szDumy.Format("%02X ", Receive_Data[i+2]);
		szMsg += szDumy;
	}
	szMsg += _T(", ");

	// Trans Data Length
	szDumy.Format(" : %d, ", byDumy);
	szMsg += szDumy;

	// Trans Data
	szMsg += _T("۽ Ÿ : ");
	for(i=0; i<(int)byDumy; i++)
	{
		szDumy.Format("%02X ", Receive_Data[i+6]);
		szMsg += szDumy;
	}

	AddNewMsg(szMsg);
}

void CMainFrame::DataReadAns()
{
	BOOL bRet;
	int nLength=0x0;
	CString szDumy, szProtocol, szArbitor, szLength, szHex, szAsc;

	// CAN Protocol & CAN Receive Arbiter
	if(Receive_Data[1] >= 128)
	{
		szProtocol =  _T("Ext(2.0B)");
		szDumy.Format(_T("%02X %02X %02X %02X"), Receive_Data[2], Receive_Data[3],
			Receive_Data[4], Receive_Data[5]);
		szArbitor = szDumy;
	}
	else
	{
		szProtocol =  _T("Std(2.0A)");
		szDumy.Format(_T("%02X %02X"), Receive_Data[2], Receive_Data[3]);
		szArbitor = szDumy;
	}

	// Receive Length
	nLength = (int)(Receive_Data[1] % 128);
	szLength.Format(_T("%d"), nLength);

	// Receive Data
	szHex.Empty();
	szAsc.Empty();
	for(int i=0; i<nLength; i++)
	{
		szDumy.Format(_T("%02X "), Receive_Data[i+6]);
		szHex += szDumy;
		szDumy.Format(_T("%c"), (char)Receive_Data[i+6]);
		szAsc += szDumy;
	}

	CCanDoc* pDoc = (CCanDoc*)GetActiveDocument();
	POSITION pos = pDoc->GetFirstViewPosition();
	while(pos != NULL)
	{
		if(::IsWindow(this->m_hWnd))
		{
			CView* pNextView = pDoc->GetNextView(pos);
			if(pNextView->GetSafeHwnd() != NULL)
			{
				if(pNextView->IsKindOf(RUNTIME_CLASS(CRightView)))
				{
					bRet = ((CRightView*)pNextView)->AddNewData(szProtocol, szArbitor, szLength, szHex, szAsc);
					if(!bRet)
					{
						ReceiveStop();
						((CRightView*)pNextView)->ClearData();
					}
				}
			}
			else
				break;
		}
		else
			break;
	}
}

void CMainFrame::ReadDevInfo()
{
	if(!m_bDeviceExist)
		return;

	if(!m_bPortOpened)
	{
		if(!OpenComPort())
		{
			AddNewMsg(_T("ø Ʈ µ ϴ."), CLR_RED);
			return;
		}
	}

	if(!ReadCanEnv())
	{
		AddNewMsg(_T("CAN Analyzer   дµ ϴ."), CLR_RED);
		CloseComPort();
		return;
	}
}

void CMainFrame::WriteDevInfo(CString szCommand)
{
	if(!m_bDeviceExist)
		return;

	if(!m_bPortOpened)
	{
		if(!OpenComPort())
		{
			AddNewMsg(_T("ø Ʈ µ ϴ."), CLR_RED);
			return;
		}
	}

	if(!WriteCanEnv(szCommand))
	{
		AddNewMsg(_T("CAN Analyzer   µ ϴ."), CLR_RED);
		CloseComPort();
		return;
	}
}

void CMainFrame::ReceiveStart()
{
	if(!m_bDeviceExist)
		return;

	if(!m_bPortOpened)
	{
		if(!OpenComPort())
		{
			AddNewMsg(_T("ø Ʈ µ ϴ."), CLR_RED);
			return;
		}
	}

	if(SetRcvON())
	{
		m_bCommSetON = TRUE;
		SetTimer(2002, 1000, NULL);
	}
	else
		WriteCommError();
}

void CMainFrame::ReceiveStop()
{
	if(!m_bDeviceExist)
		return;

	if(!m_bPortOpened)
	{
		if(!OpenComPort())
		{
			AddNewMsg(_T("ø Ʈ µ ϴ."), CLR_RED);
			return;
		}
	}

	if(SetRcvOFF())
	{
		m_bCommSetON = TRUE;
		SetTimer(2002, 1000, NULL);
	}
	else
		WriteCommError();
}

void CMainFrame::DevReset()
{
	if(!m_bDeviceExist)
		return;

	if(!m_bPortOpened)
	{
		if(!OpenComPort())
		{
			AddNewMsg(_T("ø Ʈ µ ϴ."), CLR_RED);
			return;
		}
	}

	if(SetDevReset())
	{
		m_bCommSetON = TRUE;
		SetTimer(2002, 1000, NULL);
	}
	else
		WriteCommError();
}

void CMainFrame::SendTranData(CString szCommand)
{
	if(!m_bDeviceExist)
		return;

	if(!m_bPortOpened)
	{
		if(!OpenComPort())
		{
			AddNewMsg(_T("ø Ʈ µ ϴ."), CLR_RED);
			return;
		}
	}

	if(ModBusDWrite(szCommand))
	{
		m_bCommSetON = TRUE;
		SetTimer(2002, 1000, NULL);
	}
	else
		WriteCommError();
}

void CMainFrame::OnReceiveStart()
{
	// TODO: Add your command handler code here
	ReceiveStart();
}

void CMainFrame::OnReceiveStop()
{
	// TODO: Add your command handler code here
	ReceiveStop();
}

void CMainFrame::OnReset()
{
	// TODO: Add your command handler code here
	DevReset();
}

void CMainFrame::DoReceiveStart()
{
	OnReceiveStart();
}

void CMainFrame::DoReceiveStop()
{
	OnReceiveStop();
}
