// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__C2DA486F_134D_420B_B714_07921A939955__INCLUDED_)
#define AFX_MAINFRM_H__C2DA486F_134D_420B_B714_07921A939955__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CQueue

#define  BUFF_SIZE		8192
#define  WM_COMM_READ	(WM_USER+1)

class CQueue
{
public:
	CQueue();
	~CQueue();

	char	RX_BUF[BUFF_SIZE];
	int		m_nHead, m_nTail;
	void	Clear();		       // Queue ʱȭ
	int		GetSize();			   // Queue ִ ڷ .
	BOOL	PutData(char cData);   // Queue 1Byte Ÿ .
	BOOL	GetData(char* pcData); // Queue 1Byte Ÿ .
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

class CMainFrame : public CFrameWnd
{
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:
	// Registry Info
	UINT  m_nComPort;
	UINT  m_nBps;
	UINT  m_nProtocol;
	DWORD m_nTranArbitor;
	DWORD m_nLowData;
	DWORD m_nHighData;
	UINT  m_nTranMode;
	UINT  m_nLength;
	UINT  m_nEditMode;
	DWORD m_nRecMask;
	DWORD m_nRecArbitor;

// Operations
public:
	// Device  Լ
	void ReadDevInfo();
	void WriteDevInfo(CString szCommand);
	void ReceiveStart();
	void ReceiveStop();
	void DevReset();
	void SendTranData(CString szCommand);

	// COM Port 
	BOOL  OpenComPort();
	void  CloseComPort();
	DWORD WriteComm(char* pBuff, DWORD nToWrite);
	DWORD ReadComm(char* pBuff, DWORD nToRead);
	void  WriteCommError();

	// Thread 
	BOOL MakeComThread();
	BOOL DestroyComThread();
	static UINT ComThreadProc(LPVOID lParam);

	// ASCII MODBUF Protocol for CAN Action
	BOOL SetRcvON();
	BOOL SetRcvOFF();
	BOOL SetDevReset();
	BOOL ReadCanEnv();
	BOOL WriteCanEnv(CString szCommand);
	BOOL ModBusDWrite(CString szCommand);

	BOOL ModBusReceive(LPCTSTR szData, int nLength);
	void SetReadAns(BOOL bWrite);
	void DataReadAns();
	void DataWriteAns();
	void DevResetAns();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar    m_wndStatusBar;
	CToolBar	  m_wndToolBar;

// Generated message map functions
protected:
	// COM Port 
	BOOL		m_bPortOpened;
	HANDLE		m_hComID;
	OVERLAPPED	m_osRead;
	OVERLAPPED	m_osWrite;

	// Thread 
	BOOL		m_bExitThread;
	HANDLE		m_hComThread;

	// Data Queue 
	CQueue		m_Queue;

	// Basic  
	BOOL		m_bReceiveON;
	BOOL		m_bCommSetON;

	// ModBus 
	BOOL		m_bAsEnd;
	BOOL		m_bAsRON;
	int			m_nAsRCnt;
	BYTE		Receive_Buff[100];
	BYTE		Receive_Data[20];

	// CAN Monitoring Device  
	BOOL        m_bDeviceExist;

	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnReceiveStart();
	afx_msg void OnReceiveStop();
	afx_msg void OnReset();
	//}}AFX_MSG
	afx_msg LONG OnReadRxData(WPARAM, LPARAM);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__C2DA486F_134D_420B_B714_07921A939955__INCLUDED_)
